/*
 *  Interactive disassembler (IDA).
 *  NEC V830 module
 */

#ifndef _V830_HPP
#define _V830_HPP

#include "../idaidp.hpp"
#include "ins.hpp"

//------------------------------------------------------------------------
// customization of cmd structure:

#define o_ind_mem   o_idpspec0      // @intmem
#define o_ind_reg   o_idpspec1      // @Rx

extern ea_t intmem;

//------------------------------------------------------------------------

enum v830_registers
{
  rR0,  rR1,  rR2,   rR3,   rR4,   rR5,   rR6,   rR7,
  rR8,  rR9,  rR10,  rR11,  rR12,  rR13,  rR14,  rR15,
  rR16,  rR17,  rR18,   rR19,   rR20,   rR21,   rR22,   rR23,
  rR24,  rR25,  rR26,  rR27,  rR28,  rR29,  rR30,  rR31,
  rVcs, rVds
};

typedef struct
{
  uchar addr;
  char *name;
  char *cmt;
} predefined_t;

extern predefined_t iregs[];

//------------------------------------------------------------------------

void __stdcall header( void );
void __stdcall footer( void );

void __stdcall segstart( ea_t ea );
void __stdcall segend( ea_t ea );

int  __stdcall ana( void );
int  __stdcall emu( void );
void __stdcall out( void );
bool __stdcall outop( op_t &op );

void __stdcall v830_data( ea_t ea );

#endif
